;-------------------------------------------------------------------------------
;custom items 1.1
;-------------------------------------------------------------------------------

header
hirom

;-------------------------------------------------------------------------------
;nulls hard coded replacement of items for spells: specific tools, skeans
;-------------------------------------------------------------------------------

org     $C22708
        JMP $2719
warnpc  $C22719

;---------------------------------------;---------------------------------------
;add special effect for common items
;---------------------------------------;---------------------------------------

org     $C24329
        dw item_special_effect
warnpc  $C2432B

;-------------------------------------------------------------------------------
;check if item need adjustment
;-------------------------------------------------------------------------------

org     $C22ADC

        ;get item type
        LDA $D85000,X                   ;item type
        AND #$07                        ;isolate bytes

        ;check for tool type
        CMP #$00                        ;tool id
        BEQ tool_adjustment

        ;check for item type
        CMP #$06                        ;item id
        BNE exit

        ;check if item can be throw
        LDA $D85000,X                   ;item type
        AND #$10                        ;'can be throw' flag
        BNE skean_adjustment

        ;check magical item
        LDA $D85000,X                   ;item type
        AND #$80                        ;magic item
        BNE magic_item_adjustment

        ;execute normal item
        BRA common_item_adjustment

exit:
        ;exit
        PLA
        PLP
        PLX
        RTS

;-------------------------------------------------------------------------------
;tool/skean/items adjustment
;-------------------------------------------------------------------------------

tool_adjustment:
        JSR spell_reload                ;reload spell data
        LDA $D85015,X                   ;load tool hit rate (animation)
        CMP #$09                        ;max tool animation
        BCS exit
        STA $B6                         ;command index (tool animation)
        LDA #$09                        ;tools command
        STA $B5                         ;save command
        BRA exit

skean_adjustment:
        JSR spell_reload
        BRA exit

magic_item_adjustment:
        LDA $D85014,X                   ;item power
        STA $3400
        BRA exit

common_item_adjustment:
        LDA $11A9                       ;item special effect
        CMP #$00                        ;no special effect
        BNE exit                        ;exit if special effect present
        LDA #$48                        ;multiplier special effect
        STA $11A9                       ;save it
        BRA exit

;-------------------------------------------------------------------------------
;reload almost all spell data
;-------------------------------------------------------------------------------

spell_reload:
        ;load spell data
        LDA $D85014,X                   ;load tool/skean/item power(spell index)
        PHA
        JSR $2966                       ;load spell data
        STZ $11A5                       ;null spell cost
        PLA

        ;setup default animation
        STA $B6                         ;save spell index
        JSR $1DBF                       ;choose command based on spell index
        STA $B5                         ;save command

        ;special setting
        STZ $BD                         ;null increment on damage

        ;return
        RTS

;-------------------------------------------------------------------------------
;item special effect
;-------------------------------------------------------------------------------

item_special_effect:
        
        ;don't allow damage modification
        STZ $3414                       ;don't allow damage modification

        ;calculate new damage: damage = $11A6 * #$50
        LDA $11A6                       ;spell power
        XBA
        LDA #$32                        ;multiplier
        JSR $4781                       ;multiply item power * multiplier

        ;save ned damage
        REP #$20                        ;set C
        STA $11B0                       ;set damage
        SEP #$20                        ;set A

        ;exit
        RTS

warnpc  $C22B63

;---------------------------------------;---------------------------------------
;adjustment for hp items used in menu
;---------------------------------------;---------------------------------------

org     $C38C4F
        LDA $D85014,X                   ;A = item power, B = garbage
        JSL menu_hp_item 
warnpc  $C38C57

;---------------------------------------;---------------------------------------
;adjustment for mp items used in menu
;---------------------------------------;---------------------------------------

org     $C38C68
        LDA $D85014,X                   ;A = item power, B = garbage
        JSL menu_mp_item
warnpc  $C38C70

;---------------------------------------;---------------------------------------
;erase check of status/hp/mp for item usage
;---------------------------------------;---------------------------------------

org     $C38B3D

        SEC
        RTS

;-------------------------------------------------------------------------------
;items used in menu
;-------------------------------------------------------------------------------

menu_hp_item:

        JSR multiply                    ;multiply by 50
        ADC $0009,Y                     ;add to current HP
        STA $0009,Y                     ;save at current HP
        RTL

menu_mp_item:
        JSR multiply                    ;multiply by 50
        ADC $000D,Y                     ;add to current MP
        STA $000D,Y                     ;save at current MP
        RTL

multiply:

        ;setup multipliers
        SEP #$20                        ;set A register
        STA $4202                       ;setup multiplier 1 as item power
        LDA #$32
        STA $4203                       ;setup multiplier 2 as 50

        ;wait cycles to fetch result
        NOP
        NOP
        NOP
        NOP

        ;get result
        REP #$20                        ;set C register
        LDA $4216                       ;get result: C = item power * 50

        ;exit
        RTS

warnpc  $C38C2B
